var Class = require("core").Class;
var IResourceCache = require('./IResourceCache.js').IResourceCache;
var jqtpl = require('jqtpl');

/**
 * @class In-memory resource Cache for jQuery Templates
 * @requires Class
 * @requires IResourceCache
 * @requires jqtpl
 */
var JqTplCache = function(){

    /** @ignore */
    this.Implements = IResourceCache;

    /**
     * cache resource in memory
     * 
     * @param {String} path
     * @param {String} contents
     */
    this.cache = function(path, contents){
        console.log('Caching JqTpl  template: ' + path);
        
        // caching
        jqtpl.template(path, contents);
    };
};

JqTplCache = new Class(new JqTplCache());
exports.JqTplCache = JqTplCache;