var Class = require("core").Class;
var IResourceCache = require('./IResourceCache.js').IResourceCache;

/**
 * @class In-memory resource Cache for Stylus Templates
 * @extends IResourceCache
 * @requires Class
 * @requires IResourceCache
 *
 * @param {Object} configuration
 */
var StylusCache = function(){

    /** @ignore */
    this.Implements = IResourceCache;

    /** @ignore */
    this.initialize = function(configuration){
        this._configuration = configuration;
        GLOBAL['stylus'] = {};
    };

    /**
     * cache resource in memory
     *
     * @param {String} path
     * @param {String} contents
     */
    this.cache = function(path, contents){
        console.log('Caching Stylus template: ' + path);

        // caching stylus template
        GLOBAL['stylus'][path] = contents;
    };
};

StylusCache = new Class(new StylusCache());
exports.StylusCache = StylusCache;