describe('DriverAbstract', function(){
    var DriverAbstract = Class = null;
    var TestDriver = TestDriverImplementation = null;

    it('loading dependencies', function(){
        expect(function(){
            DriverAbstract = require('../lib/DriverAbstract.js').DriverAbstract;
        }).not.toThrow();

        expect(function(){
            Class = require("../lib/mootools/mootools-node.js").Class;
        }).not.toThrow();
    });
    
    it('creating test drivers', function(){
        expect(function(){
            TestDriver = function(){
                this.Extends = DriverAbstract;
                this.initialize = function(){};
            };
            TestDriver = new Class(new TestDriver());
        }).not.toThrow();
        
        expect(function(){
            TestDriverImplementation = function(){
                this.Extends = DriverAbstract;
                
                this.initialize = function(){};
                this.load = function(){};
            };
            TestDriverImplementation = new Class(new TestDriverImplementation());
        }).not.toThrow();
    });
    
    it('creation', function(){
        expect(function(){
            var driver = new DriverAbstract();
        }).toThrow(DriverAbstract.Exception.INITIALIZE_NOT_IMPLEMENTED);
        
        expect(function(){
            var driver = new TestDriver();
        }).not.toThrow(DriverAbstract.Exception.INITIALIZE_NOT_IMPLEMENTED);
        
        expect(function(){
            var driver = new TestDriverImplementation();
        }).not.toThrow(DriverAbstract.Exception.INITIALIZE_NOT_IMPLEMENTED);
    });
    
    it('load', function(){
       
        expect(function(){
            var driver = new TestDriver();
            driver.load();
        }).toThrow(DriverAbstract.Exception.LOAD_NOT_IMPLEMENTED);
        
        expect(function(){
            var driver = new TestDriverImplementation();
            driver.load();
        }).not.toThrow(DriverAbstract.Exception.LOAD_NOT_IMPLEMENTED);
    });

});