describe('DriverLocal', function(){
    var DriverLocal = DriverAbstract = null;

    it('loading dependencies', function(){
        expect(function(){
            DriverLocal = require('../lib/DriverLocal.js').DriverLocal;
        }).not.toThrow();
        
        expect(function(){
            DriverAbstract = require('../lib/DriverAbstract.js').DriverAbstract;
        }).not.toThrow();
    });
    
    it('creating', function(){
        expect(function(){ new DriverLocal(); }).toThrow(DriverLocal.Exception.NO_DATA_GIVEN);

        expect(function(){ new DriverLocal(null); }).toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        expect(function(){ new DriverLocal(undefined); }).toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        
        expect(function(){ new DriverLocal(123); }).not.toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        expect(function(){ new DriverLocal("eloszka"); }).not.toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        expect(function(){ new DriverLocal([]); }).not.toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        expect(function(){ new DriverLocal({}); }).not.toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
        expect(function(){ new DriverLocal(new (function(){})); }).not.toThrow(DriverLocal.Exception.NO_DATA_GIVEN);
    });
    
    it('load', function(){
        var responseEvent = null, testData = 1234567890;

        runs(function(){
            var driver = new DriverLocal(testData);
            
            driver.addEventListener(DriverAbstract.LOADED, function(e){ responseEvent = e; });
            
            driver.load();
        });
        
        waitsFor(function(){
            return responseEvent !== null;
        }, 1000);
        
        runs(function(){
            expect(responseEvent.type).toEqual(DriverAbstract.LOADED);
            expect(responseEvent.data).toEqual(testData);
        });
    });
});