var Class = require("core").Class;
var Event = require('core').Event.Event;

var Template = require('./Template.js').Template;
var stylus = require('stylus');


/**
 * @class StylusTemplate Stylus engine implementation. Do not use it !!!
 * @deprecated This is only proof of concept Class. Currently unstable not for production use
 * @extends Template
 * @require Class | Event | Template | stylus
 */
var StylusTemplate = function(){

    /** @ignore */
    this.Extends = Template;

    /**
     * Executing stylus template rendering
     * @param {Object}
     */
    this.render = function(data){
        if(!GLOBAL.hasOwnProperty('stylus') || !GLOBAL['stylus'].hasOwnProperty(this._configuration.template)){
            throw "Template: " + this._configuration.template + " doesn't exist";
        }

        // create new stylus object passing stylus css source code
        var stylusInstance = stylus(GLOBAL['stylus'][this._configuration.template]);

        // setting mock filename for better error reporting
        stylusInstance.set('filename', this._configuration.template);

        // defining stylesheet variables
        if(data && data.hasOwnProperty('data')){
            for(var dataKey in data.data ){
                if(data.data.hasOwnProperty(dataKey)){
                    stylusInstance.define(dataKey, new stylus.nodes.Unit(data.data[dataKey]));
                }
            }
        }

        // rendering stylesheet template
        var that = this;
        stylusInstance.render(function(err, css){
            if(err) throw err;
            that.setRenderedData(css);
        });
        
    };

};

StylusTemplate = new Class(new StylusTemplate());
exports.StylusTemplate = StylusTemplate;